# TODO:
# - package vendored modules

%define		fzfrev		6432f00
%define		fzfvimrev	0a80e43
%define		fzfgitrev	bd8ac4b
%define		vendor_version	0.52.1

Summary:	A command-line fuzzy finder written in Go
Name:		fzf
Version:	0.52.1
Release:	1
License:	MIT
Group:		Applications/Shells
#Source0Download: https://github.com/junegunn/fzf/releases
Source0:	https://github.com/junegunn/fzf/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	eb55cb5328f22d07faa9ce6ddf5557a3
# cd fzf-%{version}
# go mod vendor
# cd ..
# tar cJf fzf-vendor-%{version}.tar.xz fzf-%{version}/vendor
Source1:	%{name}-vendor-%{vendor_version}.tar.xz
# Source1-md5:	a1c48b3405dbd711133886fd04e947e7
Source2:	https://github.com/junegunn/fzf.vim/archive/%{fzfvimrev}/fzf.vim-%{fzfvimrev}.tar.gz
# Source2-md5:	19094c9ad31122638123464052e0f4de
Source3:	https://github.com/junegunn/fzf-git.sh/archive/%{fzfgitrev}/fzf-git.sh-%{fzfgitrev}.tar.gz
# Source3-md5:	8f9832067fa77e2b54df16bafdea0eb2
Patch0:		install.patch
URL:		https://github.com/junegunn/fzf
BuildRequires:	golang >= 1.20
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpmbuild(macros) >= 2.009
BuildRequires:	sed >= 4.0
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
ExclusiveArch:	%go_arches
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_debugsource_packages	0

%description
fzf is a general-purpose command-line fuzzy finder.

It's an interactive Unix filter for command-line that can be used with
any list; files, command history, processes, hostnames, bookmarks, git
commits, etc.

%package tmux
Summary:	Script for starting fzf in tmux pane
Requires:	%{name} = %{version}-%{release}
Requires:	coreutils
Requires:	tmux
BuildArch:	noarch

%description tmux
Script for starting fzf in tmux pane.

%package -n bash-completion-fzf
Summary:	bash-completion for fzf
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	bash-completion >= 1:2.0
BuildArch:	noarch

%description -n bash-completion-fzf
bash-completion for fzf.

%package -n zsh-completion-fzf
Summary:	zsh-completion for fzf
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	zsh
BuildArch:	noarch

%description -n zsh-completion-fzf
zsh-completion for fzf.

%package git-sh
Summary:	bash and zsh key bindings for Git objects, powered by fzf
Group:		Applications/Shells
Requires:	%{name}-tmux
Requires:	awk
Requires:	coreutils
Requires:	git-core
Requires:	grep
Requires:	sed
Suggests:	xdg-utils
BuildArch:	noarch

%description git-sh
bash and zsh key bindings for Git objects, powered by fzf.

%package -n vim-plugin-fzf
Summary:	fzf integration for Vim
Group:		Applications/Editors/Vim
Requires:	%{name} >= 0.23.0
Requires:	file
Requires:	vim-rt
Suggests:	highlight
Suggests:	ripgrep
Suggests:	the_silver_searcher
BuildArch:	noarch

%description -n vim-plugin-fzf
fzf integration for Vim.

%package -n vim-plugin-fzf-doc
Summary:	Documentation for fzf Vim plugin
Group:		Applications/Editors/Vim
Requires:	vim-plugin-fzf = %{version}-%{release}
Requires:	vim-rt
BuildArch:	noarch

%description -n vim-plugin-fzf-doc
Documentation for fzf Vim plugin.

%prep
%setup -q -a1 -a2 -a3
%{__mv} fzf-%{vendor_version}/vendor .
%{__mv} fzf.vim-%{fzfvimrev}* fzf.vim
%{__mv} fzf-git.sh-%{fzfgitrev}* fzf-git
%patch0 -p1
%{__sed} -i -e "s@let s:bin_dir = .*@let s:bin_dir = '%{_datadir}/fzf/vim/bin/'@" fzf.vim/autoload/fzf/vim.vim
%{__sed} -i -e '1s,.*env bash,#!/bin/bash,' fzf.vim/bin/preview.sh bin/fzf-tmux install
%{__sed} -i -e '1s,.*env perl,#!%{__perl},' fzf.vim/bin/tags.pl

%{__mkdir_p} .go-cache

%build
%__go build -v -mod=vendor -ldflags='-X main.version=%{version} -X main.revision=%{fzfrev}' -o target/fzf

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{_bindir},%{_datadir}/fzf/vim/bin,%{_mandir}/man1,%{bash_compdir},%{zsh_compdir}}
install -d $RPM_BUILD_ROOT%{_datadir}/vim/{doc,autoload,plugin/fzf}

install -p target/fzf $RPM_BUILD_ROOT%{_bindir}/fzf
install -p install $RPM_BUILD_ROOT%{_bindir}/fzf-install
install -p bin/fzf-tmux $RPM_BUILD_ROOT%{_bindir}/fzf-tmux
cp -p man/man1/fzf.1 $RPM_BUILD_ROOT%{_mandir}/man1
cp -p shell/completion.bash $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/key-bindings.bash $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/completion.zsh $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p shell/key-bindings.zsh $RPM_BUILD_ROOT%{_datadir}/fzf
cp -p fzf-git/fzf-git.sh $RPM_BUILD_ROOT%{_datadir}/fzf
cp -rp fzf.vim/autoload/fzf $RPM_BUILD_ROOT%{_datadir}/vim/autoload
cp -p plugin/fzf.vim $RPM_BUILD_ROOT%{_datadir}/vim/plugin/fzf.vim
cp -p fzf.vim/plugin/fzf.vim $RPM_BUILD_ROOT%{_datadir}/vim/plugin/fzf/fzf.vim
cp -p fzf.vim/doc/fzf-vim.txt $RPM_BUILD_ROOT%{_datadir}/vim/doc/fzf.txt
cp -p fzf.vim/bin/{preview.sh,tags.pl} $RPM_BUILD_ROOT%{_datadir}/fzf/vim/bin

%clean
rm -rf $RPM_BUILD_ROOT

%post
%banner -o -e %{name} <<EOF
==> Caveats
To install useful keybindings and fuzzy completion:
  fzf-install
EOF

%post -n vim-plugin-fzf-doc
%vim_doc_helptags

%postun -n vim-plugin-fzf-doc
%vim_doc_helptags

%files
%defattr(644,root,root,755)
%doc BUILD.md CHANGELOG.md README.md
%attr(755,root,root) %{_bindir}/fzf
%attr(755,root,root) %{_bindir}/fzf-install
%dir %{_datadir}/fzf
%{_mandir}/man1/fzf.1*

%files tmux
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/fzf-tmux

%files -n bash-completion-fzf
%defattr(644,root,root,755)
%{_datadir}/fzf/completion.bash
%{_datadir}/fzf/key-bindings.bash

%files -n zsh-completion-fzf
%defattr(644,root,root,755)
%{_datadir}/fzf/completion.zsh
%{_datadir}/fzf/key-bindings.zsh

%files git-sh
%defattr(644,root,root,755)
%doc fzf-git/README.md
%{_datadir}/fzf/fzf-git.sh

%files -n vim-plugin-fzf
%defattr(644,root,root,755)
%doc README-VIM.md fzf.vim/README.md
%dir %{_datadir}/fzf/vim
%dir %{_datadir}/fzf/vim/bin
%attr(755,root,root) %{_datadir}/fzf/vim/bin/preview.sh
%attr(755,root,root) %{_datadir}/fzf/vim/bin/tags.pl
%{_datadir}/vim/autoload/fzf
%{_datadir}/vim/plugin/fzf.vim
%{_datadir}/vim/plugin/fzf

%files -n vim-plugin-fzf-doc
%defattr(644,root,root,755)
%{_datadir}/vim/doc/fzf.txt
%changelog
* Sun Jun 02 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/fzf.git;a=log;h=master

* Sat Jun 01 2024 Jan Palus <atler@pld-linux.org> 2f3ee72
- up to 0.52.1

* Mon Apr 15 2024 Jan Palus <atler@pld-linux.org> 5e6b1d9
- up to 0.50.0

* Sun Mar 17 2024 Jan Palus <atler@pld-linux.org> 8c112c2
- up to 0.48.1

* Mon Mar 11 2024 Jan Palus <atler@pld-linux.org> 3373611
- up to 0.47.0

* Tue Jan 23 2024 Jan Palus <atler@pld-linux.org> 9a87809
- up to 0.46.0

* Mon Jan 01 2024 Jan Palus <atler@pld-linux.org> 442ec4c
- up to 0.45.0

* Fri Nov 17 2023 Jan Palus <atler@pld-linux.org> f716a89
- up to 0.44.1

* Sun Nov 12 2023 Jan Palus <atler@pld-linux.org> b111790
- up to 0.44.0

* Sat Oct 14 2023 Jan Palus <atler@pld-linux.org> e92d628
- up to 0.43.0

* Wed Jun 14 2023 Jan Palus <atler@pld-linux.org> 9c05265
- up to 0.42.0

* Sat May 27 2023 Jan Palus <atler@pld-linux.org> fc7dca2
- up to 0.41.1

* Fri May 26 2023 Jan Palus <atler@pld-linux.org> 228cda5
- up to 0.41.0

* Mon May 01 2023 Jan Palus <atler@pld-linux.org> d3ed991
- up to 0.40.0

* Sun Apr 02 2023 Jan Palus <atler@pld-linux.org> afd7613
- up to 0.39.0

* Wed Feb 15 2023 Jan Palus <atler@pld-linux.org> 7912f7a
- up to 0.38.0

* Tue Jan 24 2023 Jan Palus <atler@pld-linux.org> b63d692
- up to 0.37.0

* Mon Jan 16 2023 Jan Palus <atler@pld-linux.org> 64afb3e
- up to 0.36.0

* Tue Dec 20 2022 Jan Rękorajski <baggins@pld-linux.org> ef0f890
- Release 2 (by relup.sh)

* Fri Nov 18 2022 Jan Palus <atler@pld-linux.org> 0caddac
- up to 0.35.1

* Sat Nov 12 2022 Jan Palus <atler@pld-linux.org> ef6f4d7
- up to 0.35.0

